# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from data_repo_client.paths.api_repository_v1_datasets_id_assets.post import AddDatasetAssetSpecifications
from data_repo_client.paths.api_repository_v1_datasets_id_policies_policy_name_members.post import AddDatasetPolicyMember
from data_repo_client.paths.api_repository_v1_datasets_id_deletes.post import ApplyDatasetDataDeletion
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk.post import BulkFileLoad
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk_array.post import BulkFileLoadArray
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk_load_tag.delete import BulkFileResultsDelete
from data_repo_client.paths.api_repository_v1_datasets_id_transactions_transaction_id.post import CloseTransaction
from data_repo_client.paths.api_repository_v1_datasets.post import CreateDataset
from data_repo_client.paths.api_repository_v1_datasets_id.delete import DeleteDataset
from data_repo_client.paths.api_repository_v1_datasets_id_policies_policy_name_members_member_email.delete import DeleteDatasetPolicyMember
from data_repo_client.paths.api_repository_v1_datasets_id_files_fileid.delete import DeleteFile
from data_repo_client.paths.api_repository_v1_datasets.get import EnumerateDatasets
from data_repo_client.paths.api_repository_v1_datasets_id_transactions.get import EnumerateTransactions
from data_repo_client.paths.api_repository_v1_datasets_tags.get import GetDatasetTags
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk_load_tag.get import GetLoadHistoryForLoadTag
from data_repo_client.paths.api_repository_v1_datasets_id_ingest.post import IngestDataset
from data_repo_client.paths.api_repository_v1_datasets_id_files.post import IngestFile
from data_repo_client.paths.api_repository_v1_datasets_id_data_table.get import LookupDatasetDataById
from data_repo_client.paths.api_repository_v1_datasets_id_files_fileid.get import LookupFileById
from data_repo_client.paths.api_repository_v1_datasets_id_filesystem_objects.get import LookupFileByPath
from data_repo_client.paths.api_repository_v1_datasets_id_transactions.post import OpenTransaction
from data_repo_client.paths.api_repository_v1_datasets_id.patch import PatchDataset
from data_repo_client.paths.api_repository_v1_datasets_id_assets_assetid.delete import RemoveDatasetAssetSpecifications
from data_repo_client.paths.api_repository_v1_datasets_id.get import RetrieveDataset
from data_repo_client.paths.api_repository_v1_datasets_id_policies.get import RetrieveDatasetPolicies
from data_repo_client.paths.api_repository_v1_datasets_id_summary.get import RetrieveDatasetSummary
from data_repo_client.paths.api_repository_v1_datasets_id_transactions_transaction_id.get import RetrieveTransaction
from data_repo_client.paths.api_repository_v1_datasets_id_roles.get import RetrieveUserDatasetRoles
from data_repo_client.paths.api_repository_v1_datasets_id_tags.patch import UpdateDatasetTags
from data_repo_client.paths.api_repository_v1_datasets_id_update_schema.post import UpdateSchema


class DatasetsApi(
    AddDatasetAssetSpecifications,
    AddDatasetPolicyMember,
    ApplyDatasetDataDeletion,
    BulkFileLoad,
    BulkFileLoadArray,
    BulkFileResultsDelete,
    CloseTransaction,
    CreateDataset,
    DeleteDataset,
    DeleteDatasetPolicyMember,
    DeleteFile,
    EnumerateDatasets,
    EnumerateTransactions,
    GetDatasetTags,
    GetLoadHistoryForLoadTag,
    IngestDataset,
    IngestFile,
    LookupDatasetDataById,
    LookupFileById,
    LookupFileByPath,
    OpenTransaction,
    PatchDataset,
    RemoveDatasetAssetSpecifications,
    RetrieveDataset,
    RetrieveDatasetPolicies,
    RetrieveDatasetSummary,
    RetrieveTransaction,
    RetrieveUserDatasetRoles,
    UpdateDatasetTags,
    UpdateSchema,
):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    pass
