# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from data_repo_client.paths.api_repository_v1_datasets_id_assets.post import AddDatasetAssetSpecifications
from data_repo_client.paths.api_repository_v1_datasets_id_policies_policy_name_members.post import AddDatasetPolicyMember
from data_repo_client.paths.api_repository_v1_snapshots_id_policies_policy_name_members.post import AddSnapshotPolicyMember
from data_repo_client.paths.api_repository_v1_datasets_id_deletes.post import ApplyDatasetDataDeletion
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk.post import BulkFileLoad
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk_array.post import BulkFileLoadArray
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk_load_tag.delete import BulkFileResultsDelete
from data_repo_client.paths.api_repository_v1_datasets_id_transactions_transaction_id.post import CloseTransaction
from data_repo_client.paths.api_repository_v1_datasets.post import CreateDataset
from data_repo_client.paths.api_repository_v1_search_id_index.post import CreateSearchIndex
from data_repo_client.paths.api_repository_v1_snapshots.post import CreateSnapshot
from data_repo_client.paths.api_repository_v1_datasets_id.delete import DeleteDataset
from data_repo_client.paths.api_repository_v1_datasets_id_policies_policy_name_members_member_email.delete import DeleteDatasetPolicyMember
from data_repo_client.paths.api_repository_v1_datasets_id_files_fileid.delete import DeleteFile
from data_repo_client.paths.api_repository_v1_snapshots_id.delete import DeleteSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id_policies_policy_name_members_member_email.delete import DeleteSnapshotPolicyMember
from data_repo_client.paths.api_repository_v1_datasets.get import EnumerateDatasets
from data_repo_client.paths.api_repository_v1_jobs.get import EnumerateJobs
from data_repo_client.paths.api_repository_v1_snapshots.get import EnumerateSnapshots
from data_repo_client.paths.api_repository_v1_datasets_id_transactions.get import EnumerateTransactions
from data_repo_client.paths.api_repository_v1_snapshots_id_export.get import ExportSnapshot
from data_repo_client.paths.api_repository_v1_configs_name.get import GetConfig
from data_repo_client.paths.api_repository_v1_configs.get import GetConfigList
from data_repo_client.paths.api_repository_v1_datasets_tags.get import GetDatasetTags
from data_repo_client.paths.api_repository_v1_datasets_id_files_bulk_load_tag.get import GetLoadHistoryForLoadTag
from data_repo_client.paths.api_repository_v1_snapshots_role_map.get import GetSnapshotIdsAndRoles
from data_repo_client.paths.api_repository_v1_snapshots_tags.get import GetSnapshotTags
from data_repo_client.paths.api_repository_v1_datasets_id_ingest.post import IngestDataset
from data_repo_client.paths.api_repository_v1_datasets_id_files.post import IngestFile
from data_repo_client.paths.api_repository_v1_snapshots_id_link_duos_dataset_duos_id.put import LinkDuosDatasetToSnapshot
from data_repo_client.paths.api_repository_v1_datasets_id_data_table.get import LookupDatasetDataById
from data_repo_client.paths.api_repository_v1_datasets_id_files_fileid.get import LookupFileById
from data_repo_client.paths.api_repository_v1_datasets_id_filesystem_objects.get import LookupFileByPath
from data_repo_client.paths.api_repository_v1_snapshots_id_files_fileid.get import LookupSnapshotFileById
from data_repo_client.paths.api_repository_v1_snapshots_id_filesystem_objects.get import LookupSnapshotFileByPath
from data_repo_client.paths.api_repository_v1_snapshots_id_data_table.get import LookupSnapshotPreviewById
from data_repo_client.paths.api_repository_v1_datasets_id_transactions.post import OpenTransaction
from data_repo_client.paths.api_repository_v1_datasets_id.patch import PatchDataset
from data_repo_client.paths.api_repository_v1_snapshots_id.patch import PatchSnapshot
from data_repo_client.paths.api_repository_v1_search_query.post import QuerySearchIndices
from data_repo_client.paths.api_repository_v1_datasets_id_assets_assetid.delete import RemoveDatasetAssetSpecifications
from data_repo_client.paths.api_repository_v1_configs_reset.put import ResetConfig
from data_repo_client.paths.api_repository_v1_datasets_id.get import RetrieveDataset
from data_repo_client.paths.api_repository_v1_datasets_id_policies.get import RetrieveDatasetPolicies
from data_repo_client.paths.api_repository_v1_datasets_id_summary.get import RetrieveDatasetSummary
from data_repo_client.paths.api_repository_v1_duos_duos_id.get import RetrieveDuosFirecloudGroup
from data_repo_client.paths.api_repository_v1_duos.get import RetrieveDuosFirecloudGroups
from data_repo_client.paths.api_repository_v1_jobs_id.get import RetrieveJob
from data_repo_client.paths.api_repository_v1_jobs_id_result.get import RetrieveJobResult
from data_repo_client.paths.api_repository_v1_snapshots_id.get import RetrieveSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id_policies.get import RetrieveSnapshotPolicies
from data_repo_client.paths.api_repository_v1_snapshots_id_summary.get import RetrieveSnapshotSummary
from data_repo_client.paths.api_repository_v1_datasets_id_transactions_transaction_id.get import RetrieveTransaction
from data_repo_client.paths.api_repository_v1_datasets_id_roles.get import RetrieveUserDatasetRoles
from data_repo_client.paths.api_repository_v1_snapshots_id_roles.get import RetrieveUserSnapshotRoles
from data_repo_client.paths.api_repository_v1_configs.put import SetConfigList
from data_repo_client.paths.api_repository_v1_configs_name.put import SetFault
from data_repo_client.paths.api_repository_v1_duos_duos_id_sync_authorized_users.put import SyncDuosDatasetAuthorizedUsers
from data_repo_client.paths.api_repository_v1_duos_sync_authorized_users.put import SyncDuosDatasetsAuthorizedUsers
from data_repo_client.paths.api_repository_v1_snapshots_id_unlink_duos_dataset.delete import UnlinkDuosDatasetFromSnapshot
from data_repo_client.paths.api_repository_v1_datasets_id_tags.patch import UpdateDatasetTags
from data_repo_client.paths.api_repository_v1_datasets_id_update_schema.post import UpdateSchema
from data_repo_client.paths.api_repository_v1_snapshots_id_tags.patch import UpdateSnapshotTags
from data_repo_client.paths.api_repository_v1_upgrade.post import Upgrade
from data_repo_client.paths.api_repository_v1_register_user.get import User


class RepositoryApi(
    AddDatasetAssetSpecifications,
    AddDatasetPolicyMember,
    AddSnapshotPolicyMember,
    ApplyDatasetDataDeletion,
    BulkFileLoad,
    BulkFileLoadArray,
    BulkFileResultsDelete,
    CloseTransaction,
    CreateDataset,
    CreateSearchIndex,
    CreateSnapshot,
    DeleteDataset,
    DeleteDatasetPolicyMember,
    DeleteFile,
    DeleteSnapshot,
    DeleteSnapshotPolicyMember,
    EnumerateDatasets,
    EnumerateJobs,
    EnumerateSnapshots,
    EnumerateTransactions,
    ExportSnapshot,
    GetConfig,
    GetConfigList,
    GetDatasetTags,
    GetLoadHistoryForLoadTag,
    GetSnapshotIdsAndRoles,
    GetSnapshotTags,
    IngestDataset,
    IngestFile,
    LinkDuosDatasetToSnapshot,
    LookupDatasetDataById,
    LookupFileById,
    LookupFileByPath,
    LookupSnapshotFileById,
    LookupSnapshotFileByPath,
    LookupSnapshotPreviewById,
    OpenTransaction,
    PatchDataset,
    PatchSnapshot,
    QuerySearchIndices,
    RemoveDatasetAssetSpecifications,
    ResetConfig,
    RetrieveDataset,
    RetrieveDatasetPolicies,
    RetrieveDatasetSummary,
    RetrieveDuosFirecloudGroup,
    RetrieveDuosFirecloudGroups,
    RetrieveJob,
    RetrieveJobResult,
    RetrieveSnapshot,
    RetrieveSnapshotPolicies,
    RetrieveSnapshotSummary,
    RetrieveTransaction,
    RetrieveUserDatasetRoles,
    RetrieveUserSnapshotRoles,
    SetConfigList,
    SetFault,
    SyncDuosDatasetAuthorizedUsers,
    SyncDuosDatasetsAuthorizedUsers,
    UnlinkDuosDatasetFromSnapshot,
    UpdateDatasetTags,
    UpdateSchema,
    UpdateSnapshotTags,
    Upgrade,
    User,
):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    pass
