# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from data_repo_client.paths.api_repository_v1_snapshots_id_policies_policy_name_members.post import AddSnapshotPolicyMember
from data_repo_client.paths.api_repository_v1_search_id_index.post import CreateSearchIndex
from data_repo_client.paths.api_repository_v1_snapshots.post import CreateSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id.delete import DeleteSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id_policies_policy_name_members_member_email.delete import DeleteSnapshotPolicyMember
from data_repo_client.paths.api_repository_v1_snapshots.get import EnumerateSnapshots
from data_repo_client.paths.api_repository_v1_snapshots_id_export.get import ExportSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_role_map.get import GetSnapshotIdsAndRoles
from data_repo_client.paths.api_repository_v1_snapshots_tags.get import GetSnapshotTags
from data_repo_client.paths.api_repository_v1_snapshots_id_link_duos_dataset_duos_id.put import LinkDuosDatasetToSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id_files_fileid.get import LookupSnapshotFileById
from data_repo_client.paths.api_repository_v1_snapshots_id_filesystem_objects.get import LookupSnapshotFileByPath
from data_repo_client.paths.api_repository_v1_snapshots_id_data_table.get import LookupSnapshotPreviewById
from data_repo_client.paths.api_repository_v1_snapshots_id.patch import PatchSnapshot
from data_repo_client.paths.api_repository_v1_search_query.post import QuerySearchIndices
from data_repo_client.paths.api_repository_v1_snapshots_id.get import RetrieveSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id_policies.get import RetrieveSnapshotPolicies
from data_repo_client.paths.api_repository_v1_snapshots_id_summary.get import RetrieveSnapshotSummary
from data_repo_client.paths.api_repository_v1_snapshots_id_roles.get import RetrieveUserSnapshotRoles
from data_repo_client.paths.api_repository_v1_snapshots_id_unlink_duos_dataset.delete import UnlinkDuosDatasetFromSnapshot
from data_repo_client.paths.api_repository_v1_snapshots_id_tags.patch import UpdateSnapshotTags


class SnapshotsApi(
    AddSnapshotPolicyMember,
    CreateSearchIndex,
    CreateSnapshot,
    DeleteSnapshot,
    DeleteSnapshotPolicyMember,
    EnumerateSnapshots,
    ExportSnapshot,
    GetSnapshotIdsAndRoles,
    GetSnapshotTags,
    LinkDuosDatasetToSnapshot,
    LookupSnapshotFileById,
    LookupSnapshotFileByPath,
    LookupSnapshotPreviewById,
    PatchSnapshot,
    QuerySearchIndices,
    RetrieveSnapshot,
    RetrieveSnapshotPolicies,
    RetrieveSnapshotSummary,
    RetrieveUserSnapshotRoles,
    UnlinkDuosDatasetFromSnapshot,
    UpdateSnapshotTags,
):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """
    pass
