# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class AccessInfoParquetModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    General information on where snapshot or dataset tabular data lives in Azure

    """


    class MetaOapg:
        required = {
            "sasToken",
            "storageAccountId",
            "tables",
            "datasetName",
            "datasetId",
            "url",
        }
        
        class properties:
            datasetName = schemas.StrSchema
            datasetId = schemas.StrSchema
            storageAccountId = schemas.StrSchema
            url = schemas.StrSchema
            sasToken = schemas.StrSchema
            
            
            class tables(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['AccessInfoParquetModelTable']:
                        return AccessInfoParquetModelTable
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['AccessInfoParquetModelTable'], typing.List['AccessInfoParquetModelTable']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'tables':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'AccessInfoParquetModelTable':
                    return super().__getitem__(i)
            __annotations__ = {
                "datasetName": datasetName,
                "datasetId": datasetId,
                "storageAccountId": storageAccountId,
                "url": url,
                "sasToken": sasToken,
                "tables": tables,
            }
    
    sasToken: MetaOapg.properties.sasToken
    storageAccountId: MetaOapg.properties.storageAccountId
    tables: MetaOapg.properties.tables
    datasetName: MetaOapg.properties.datasetName
    datasetId: MetaOapg.properties.datasetId
    url: MetaOapg.properties.url
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["datasetName"]) -> MetaOapg.properties.datasetName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["datasetId"]) -> MetaOapg.properties.datasetId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["storageAccountId"]) -> MetaOapg.properties.storageAccountId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["url"]) -> MetaOapg.properties.url: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sasToken"]) -> MetaOapg.properties.sasToken: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tables"]) -> MetaOapg.properties.tables: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["datasetName", "datasetId", "storageAccountId", "url", "sasToken", "tables", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["datasetName"]) -> MetaOapg.properties.datasetName: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["datasetId"]) -> MetaOapg.properties.datasetId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["storageAccountId"]) -> MetaOapg.properties.storageAccountId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["url"]) -> MetaOapg.properties.url: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sasToken"]) -> MetaOapg.properties.sasToken: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tables"]) -> MetaOapg.properties.tables: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["datasetName", "datasetId", "storageAccountId", "url", "sasToken", "tables", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        sasToken: typing.Union[MetaOapg.properties.sasToken, str, ],
        storageAccountId: typing.Union[MetaOapg.properties.storageAccountId, str, ],
        tables: typing.Union[MetaOapg.properties.tables, list, tuple, ],
        datasetName: typing.Union[MetaOapg.properties.datasetName, str, ],
        datasetId: typing.Union[MetaOapg.properties.datasetId, str, ],
        url: typing.Union[MetaOapg.properties.url, str, ],
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'AccessInfoParquetModel':
        return super().__new__(
            cls,
            *_args,
            sasToken=sasToken,
            storageAccountId=storageAccountId,
            tables=tables,
            datasetName=datasetName,
            datasetId=datasetId,
            url=url,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.access_info_parquet_model_table import AccessInfoParquetModelTable
