# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class AssetModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    One asset in the data model. The table list identifies the tables in the asset. The rootTable and rootColumn indicate which value will be used as the unique identifier. The list of relationships provides the instructions for how to connect the tables. Asset tables have to be connected in a relationship hierarchy. So there cannot be two paths to the same table from the root.
    """


    class MetaOapg:
        required = {
            "rootColumn",
            "tables",
            "rootTable",
            "name",
        }
        
        class properties:
            
            
            class name(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    min_length = 1
            
            
            class tables(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['AssetTableModel']:
                        return AssetTableModel
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['AssetTableModel'], typing.List['AssetTableModel']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'tables':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'AssetTableModel':
                    return super().__getitem__(i)
        
            @staticmethod
            def rootTable() -> typing.Type['ObjectNameProperty']:
                return ObjectNameProperty
        
            @staticmethod
            def rootColumn() -> typing.Type['ColumnNameProperty']:
                return ColumnNameProperty
            
            
            class follow(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['ObjectNameProperty']:
                        return ObjectNameProperty
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['ObjectNameProperty'], typing.List['ObjectNameProperty']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'follow':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'ObjectNameProperty':
                    return super().__getitem__(i)
            __annotations__ = {
                "name": name,
                "tables": tables,
                "rootTable": rootTable,
                "rootColumn": rootColumn,
                "follow": follow,
            }
    
    rootColumn: 'ColumnNameProperty'
    tables: MetaOapg.properties.tables
    rootTable: 'ObjectNameProperty'
    name: MetaOapg.properties.name
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tables"]) -> MetaOapg.properties.tables: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rootTable"]) -> 'ObjectNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rootColumn"]) -> 'ColumnNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["follow"]) -> MetaOapg.properties.follow: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["name", "tables", "rootTable", "rootColumn", "follow", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tables"]) -> MetaOapg.properties.tables: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rootTable"]) -> 'ObjectNameProperty': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rootColumn"]) -> 'ColumnNameProperty': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["follow"]) -> typing.Union[MetaOapg.properties.follow, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["name", "tables", "rootTable", "rootColumn", "follow", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        rootColumn: 'ColumnNameProperty',
        tables: typing.Union[MetaOapg.properties.tables, list, tuple, ],
        rootTable: 'ObjectNameProperty',
        name: typing.Union[MetaOapg.properties.name, str, ],
        follow: typing.Union[MetaOapg.properties.follow, list, tuple, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'AssetModel':
        return super().__new__(
            cls,
            *_args,
            rootColumn=rootColumn,
            tables=tables,
            rootTable=rootTable,
            name=name,
            follow=follow,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.asset_table_model import AssetTableModel
from data_repo_client.model.column_name_property import ColumnNameProperty
from data_repo_client.model.object_name_property import ObjectNameProperty
