# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class BillingProfileModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        
        class properties:
            id = schemas.UUIDSchema
            billingAccountId = schemas.StrSchema
            profileName = schemas.StrSchema
            biller = schemas.StrSchema
            description = schemas.StrSchema
        
            @staticmethod
            def cloudPlatform() -> typing.Type['CloudPlatform']:
                return CloudPlatform
            tenantId = schemas.UUIDSchema
            subscriptionId = schemas.UUIDSchema
            resourceGroupName = schemas.StrSchema
            applicationDeploymentName = schemas.StrSchema
            createdDate = schemas.StrSchema
            createdBy = schemas.StrSchema
            __annotations__ = {
                "id": id,
                "billingAccountId": billingAccountId,
                "profileName": profileName,
                "biller": biller,
                "description": description,
                "cloudPlatform": cloudPlatform,
                "tenantId": tenantId,
                "subscriptionId": subscriptionId,
                "resourceGroupName": resourceGroupName,
                "applicationDeploymentName": applicationDeploymentName,
                "createdDate": createdDate,
                "createdBy": createdBy,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["billingAccountId"]) -> MetaOapg.properties.billingAccountId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["profileName"]) -> MetaOapg.properties.profileName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["biller"]) -> MetaOapg.properties.biller: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["cloudPlatform"]) -> 'CloudPlatform': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tenantId"]) -> MetaOapg.properties.tenantId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["subscriptionId"]) -> MetaOapg.properties.subscriptionId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["resourceGroupName"]) -> MetaOapg.properties.resourceGroupName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["applicationDeploymentName"]) -> MetaOapg.properties.applicationDeploymentName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["createdDate"]) -> MetaOapg.properties.createdDate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["createdBy"]) -> MetaOapg.properties.createdBy: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "billingAccountId", "profileName", "biller", "description", "cloudPlatform", "tenantId", "subscriptionId", "resourceGroupName", "applicationDeploymentName", "createdDate", "createdBy", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["billingAccountId"]) -> typing.Union[MetaOapg.properties.billingAccountId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["profileName"]) -> typing.Union[MetaOapg.properties.profileName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["biller"]) -> typing.Union[MetaOapg.properties.biller, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["cloudPlatform"]) -> typing.Union['CloudPlatform', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tenantId"]) -> typing.Union[MetaOapg.properties.tenantId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["subscriptionId"]) -> typing.Union[MetaOapg.properties.subscriptionId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["resourceGroupName"]) -> typing.Union[MetaOapg.properties.resourceGroupName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["applicationDeploymentName"]) -> typing.Union[MetaOapg.properties.applicationDeploymentName, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["createdDate"]) -> typing.Union[MetaOapg.properties.createdDate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["createdBy"]) -> typing.Union[MetaOapg.properties.createdBy, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "billingAccountId", "profileName", "biller", "description", "cloudPlatform", "tenantId", "subscriptionId", "resourceGroupName", "applicationDeploymentName", "createdDate", "createdBy", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        billingAccountId: typing.Union[MetaOapg.properties.billingAccountId, str, schemas.Unset] = schemas.unset,
        profileName: typing.Union[MetaOapg.properties.profileName, str, schemas.Unset] = schemas.unset,
        biller: typing.Union[MetaOapg.properties.biller, str, schemas.Unset] = schemas.unset,
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        cloudPlatform: typing.Union['CloudPlatform', schemas.Unset] = schemas.unset,
        tenantId: typing.Union[MetaOapg.properties.tenantId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        subscriptionId: typing.Union[MetaOapg.properties.subscriptionId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        resourceGroupName: typing.Union[MetaOapg.properties.resourceGroupName, str, schemas.Unset] = schemas.unset,
        applicationDeploymentName: typing.Union[MetaOapg.properties.applicationDeploymentName, str, schemas.Unset] = schemas.unset,
        createdDate: typing.Union[MetaOapg.properties.createdDate, str, schemas.Unset] = schemas.unset,
        createdBy: typing.Union[MetaOapg.properties.createdBy, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'BillingProfileModel':
        return super().__new__(
            cls,
            *_args,
            id=id,
            billingAccountId=billingAccountId,
            profileName=profileName,
            biller=biller,
            description=description,
            cloudPlatform=cloudPlatform,
            tenantId=tenantId,
            subscriptionId=subscriptionId,
            resourceGroupName=resourceGroupName,
            applicationDeploymentName=applicationDeploymentName,
            createdDate=createdDate,
            createdBy=createdBy,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.cloud_platform import CloudPlatform
