# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class BulkLoadArrayRequestModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Body of a bulk file load request. This variant of a bulk load provides the set of files to be loaded in the body of the request. Both the summary of the load and the per-file details of the bulk load returned in the async response (BulkLoadArrayResponseModel) Per-file details of a bulk load are also stored into the dataset tabular data store and can be retrieved directly from there, or via the GET .../bulk/{loadTag} They can be cleaned up with the DELETE .../bulk/{loadTag}
    """


    class MetaOapg:
        required = {
            "loadTag",
            "profileId",
            "loadArray",
            "maxFailedFileLoads",
        }
        
        class properties:
            profileId = schemas.UUIDSchema
            loadTag = schemas.StrSchema
            maxFailedFileLoads = schemas.IntSchema
            
            
            class loadArray(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['BulkLoadFileModel']:
                        return BulkLoadFileModel
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['BulkLoadFileModel'], typing.List['BulkLoadFileModel']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'loadArray':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'BulkLoadFileModel':
                    return super().__getitem__(i)
            bulkMode = schemas.BoolSchema
            __annotations__ = {
                "profileId": profileId,
                "loadTag": loadTag,
                "maxFailedFileLoads": maxFailedFileLoads,
                "loadArray": loadArray,
                "bulkMode": bulkMode,
            }
    
    loadTag: MetaOapg.properties.loadTag
    profileId: MetaOapg.properties.profileId
    loadArray: MetaOapg.properties.loadArray
    maxFailedFileLoads: MetaOapg.properties.maxFailedFileLoads
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["profileId"]) -> MetaOapg.properties.profileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["loadTag"]) -> MetaOapg.properties.loadTag: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["maxFailedFileLoads"]) -> MetaOapg.properties.maxFailedFileLoads: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["loadArray"]) -> MetaOapg.properties.loadArray: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bulkMode"]) -> MetaOapg.properties.bulkMode: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["profileId", "loadTag", "maxFailedFileLoads", "loadArray", "bulkMode", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["profileId"]) -> MetaOapg.properties.profileId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["loadTag"]) -> MetaOapg.properties.loadTag: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["maxFailedFileLoads"]) -> MetaOapg.properties.maxFailedFileLoads: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["loadArray"]) -> MetaOapg.properties.loadArray: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bulkMode"]) -> typing.Union[MetaOapg.properties.bulkMode, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["profileId", "loadTag", "maxFailedFileLoads", "loadArray", "bulkMode", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        loadTag: typing.Union[MetaOapg.properties.loadTag, str, ],
        profileId: typing.Union[MetaOapg.properties.profileId, str, uuid.UUID, ],
        loadArray: typing.Union[MetaOapg.properties.loadArray, list, tuple, ],
        maxFailedFileLoads: typing.Union[MetaOapg.properties.maxFailedFileLoads, decimal.Decimal, int, ],
        bulkMode: typing.Union[MetaOapg.properties.bulkMode, bool, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'BulkLoadArrayRequestModel':
        return super().__new__(
            cls,
            *_args,
            loadTag=loadTag,
            profileId=profileId,
            loadArray=loadArray,
            maxFailedFileLoads=maxFailedFileLoads,
            bulkMode=bulkMode,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.bulk_load_file_model import BulkLoadFileModel
