# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class BulkLoadHistoryModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Describes metadata about a file during a bulk load
    """


    class MetaOapg:
        required = {
            "targetPath",
            "sourcePath",
        }
        
        class properties:
            sourcePath = schemas.StrSchema
            targetPath = schemas.StrSchema
        
            @staticmethod
            def state() -> typing.Type['BulkLoadFileState']:
                return BulkLoadFileState
            fileId = schemas.StrSchema
            checksumCRC = schemas.StrSchema
            checksumMD5 = schemas.StrSchema
            error = schemas.StrSchema
            __annotations__ = {
                "sourcePath": sourcePath,
                "targetPath": targetPath,
                "state": state,
                "fileId": fileId,
                "checksumCRC": checksumCRC,
                "checksumMD5": checksumMD5,
                "error": error,
            }
    
    targetPath: MetaOapg.properties.targetPath
    sourcePath: MetaOapg.properties.sourcePath
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["sourcePath"]) -> MetaOapg.properties.sourcePath: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["targetPath"]) -> MetaOapg.properties.targetPath: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["state"]) -> 'BulkLoadFileState': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileId"]) -> MetaOapg.properties.fileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["checksumCRC"]) -> MetaOapg.properties.checksumCRC: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["checksumMD5"]) -> MetaOapg.properties.checksumMD5: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["error"]) -> MetaOapg.properties.error: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["sourcePath", "targetPath", "state", "fileId", "checksumCRC", "checksumMD5", "error", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["sourcePath"]) -> MetaOapg.properties.sourcePath: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["targetPath"]) -> MetaOapg.properties.targetPath: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["state"]) -> typing.Union['BulkLoadFileState', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileId"]) -> typing.Union[MetaOapg.properties.fileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["checksumCRC"]) -> typing.Union[MetaOapg.properties.checksumCRC, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["checksumMD5"]) -> typing.Union[MetaOapg.properties.checksumMD5, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["error"]) -> typing.Union[MetaOapg.properties.error, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["sourcePath", "targetPath", "state", "fileId", "checksumCRC", "checksumMD5", "error", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        targetPath: typing.Union[MetaOapg.properties.targetPath, str, ],
        sourcePath: typing.Union[MetaOapg.properties.sourcePath, str, ],
        state: typing.Union['BulkLoadFileState', schemas.Unset] = schemas.unset,
        fileId: typing.Union[MetaOapg.properties.fileId, str, schemas.Unset] = schemas.unset,
        checksumCRC: typing.Union[MetaOapg.properties.checksumCRC, str, schemas.Unset] = schemas.unset,
        checksumMD5: typing.Union[MetaOapg.properties.checksumMD5, str, schemas.Unset] = schemas.unset,
        error: typing.Union[MetaOapg.properties.error, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'BulkLoadHistoryModel':
        return super().__new__(
            cls,
            *_args,
            targetPath=targetPath,
            sourcePath=sourcePath,
            state=state,
            fileId=fileId,
            checksumCRC=checksumCRC,
            checksumMD5=checksumMD5,
            error=error,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.bulk_load_file_state import BulkLoadFileState
