# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class BulkLoadRequestModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Body of a bulk file load request. This variant of a bulk load provides the set of files to be loaded in a file containing the JSON form of a BulkLoadFileModel. A summary of the load results is returned in the async response (BulkLoadResponseModel) Per-file details of a bulk load are always stored into the dataset tabular data store and can be retrieved directly from there, or via the GET .../bulk/{loadTag} They can be cleaned up with the DELETE .../bulk/{loadTag}
    """


    class MetaOapg:
        required = {
            "loadTag",
            "profileId",
            "loadControlFile",
            "maxFailedFileLoads",
        }
        
        class properties:
            profileId = schemas.UUIDSchema
            loadTag = schemas.StrSchema
            maxFailedFileLoads = schemas.IntSchema
            loadControlFile = schemas.StrSchema
            bulkMode = schemas.BoolSchema
            __annotations__ = {
                "profileId": profileId,
                "loadTag": loadTag,
                "maxFailedFileLoads": maxFailedFileLoads,
                "loadControlFile": loadControlFile,
                "bulkMode": bulkMode,
            }
    
    loadTag: MetaOapg.properties.loadTag
    profileId: MetaOapg.properties.profileId
    loadControlFile: MetaOapg.properties.loadControlFile
    maxFailedFileLoads: MetaOapg.properties.maxFailedFileLoads
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["profileId"]) -> MetaOapg.properties.profileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["loadTag"]) -> MetaOapg.properties.loadTag: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["maxFailedFileLoads"]) -> MetaOapg.properties.maxFailedFileLoads: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["loadControlFile"]) -> MetaOapg.properties.loadControlFile: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bulkMode"]) -> MetaOapg.properties.bulkMode: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["profileId", "loadTag", "maxFailedFileLoads", "loadControlFile", "bulkMode", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["profileId"]) -> MetaOapg.properties.profileId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["loadTag"]) -> MetaOapg.properties.loadTag: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["maxFailedFileLoads"]) -> MetaOapg.properties.maxFailedFileLoads: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["loadControlFile"]) -> MetaOapg.properties.loadControlFile: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bulkMode"]) -> typing.Union[MetaOapg.properties.bulkMode, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["profileId", "loadTag", "maxFailedFileLoads", "loadControlFile", "bulkMode", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        loadTag: typing.Union[MetaOapg.properties.loadTag, str, ],
        profileId: typing.Union[MetaOapg.properties.profileId, str, uuid.UUID, ],
        loadControlFile: typing.Union[MetaOapg.properties.loadControlFile, str, ],
        maxFailedFileLoads: typing.Union[MetaOapg.properties.maxFailedFileLoads, decimal.Decimal, int, ],
        bulkMode: typing.Union[MetaOapg.properties.bulkMode, bool, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'BulkLoadRequestModel':
        return super().__new__(
            cls,
            *_args,
            loadTag=loadTag,
            profileId=profileId,
            loadControlFile=loadControlFile,
            maxFailedFileLoads=maxFailedFileLoads,
            bulkMode=bulkMode,
            _configuration=_configuration,
            **kwargs,
        )
