# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class BulkLoadResultModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Returned when the bulk file load job finishes.
    """


    class MetaOapg:
        
        class properties:
            loadTag = schemas.StrSchema
            jobId = schemas.StrSchema
            totalFiles = schemas.IntSchema
            succeededFiles = schemas.IntSchema
            failedFiles = schemas.IntSchema
            notTriedFiles = schemas.IntSchema
            __annotations__ = {
                "loadTag": loadTag,
                "jobId": jobId,
                "totalFiles": totalFiles,
                "succeededFiles": succeededFiles,
                "failedFiles": failedFiles,
                "notTriedFiles": notTriedFiles,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["loadTag"]) -> MetaOapg.properties.loadTag: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["jobId"]) -> MetaOapg.properties.jobId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["totalFiles"]) -> MetaOapg.properties.totalFiles: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["succeededFiles"]) -> MetaOapg.properties.succeededFiles: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["failedFiles"]) -> MetaOapg.properties.failedFiles: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["notTriedFiles"]) -> MetaOapg.properties.notTriedFiles: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["loadTag", "jobId", "totalFiles", "succeededFiles", "failedFiles", "notTriedFiles", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["loadTag"]) -> typing.Union[MetaOapg.properties.loadTag, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["jobId"]) -> typing.Union[MetaOapg.properties.jobId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["totalFiles"]) -> typing.Union[MetaOapg.properties.totalFiles, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["succeededFiles"]) -> typing.Union[MetaOapg.properties.succeededFiles, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["failedFiles"]) -> typing.Union[MetaOapg.properties.failedFiles, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["notTriedFiles"]) -> typing.Union[MetaOapg.properties.notTriedFiles, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["loadTag", "jobId", "totalFiles", "succeededFiles", "failedFiles", "notTriedFiles", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        loadTag: typing.Union[MetaOapg.properties.loadTag, str, schemas.Unset] = schemas.unset,
        jobId: typing.Union[MetaOapg.properties.jobId, str, schemas.Unset] = schemas.unset,
        totalFiles: typing.Union[MetaOapg.properties.totalFiles, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        succeededFiles: typing.Union[MetaOapg.properties.succeededFiles, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        failedFiles: typing.Union[MetaOapg.properties.failedFiles, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        notTriedFiles: typing.Union[MetaOapg.properties.notTriedFiles, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'BulkLoadResultModel':
        return super().__new__(
            cls,
            *_args,
            loadTag=loadTag,
            jobId=jobId,
            totalFiles=totalFiles,
            succeededFiles=succeededFiles,
            failedFiles=failedFiles,
            notTriedFiles=notTriedFiles,
            _configuration=_configuration,
            **kwargs,
        )
