# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class ConfigFaultCountedModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Counted fault is used to insert a fixed number of faults. A "fault test" is one call to the fault manager for a named fault. The skipFor lets you get the system to a certain stable point where you want to begin inserting faults. Insert gives the total number of faults to trigger. The rate gives the percentage of the time to insert the fault. A value of 50 would insert the fault half the time. A value of 20 would insert the fault 20% of the time . The rateStyle describes whether the fault will be fixed or random. In our 20 example, if the rate style is fixed, the fault would be skipped 4 times, inserted once, skipped 4 times, inserted once, etc. It uses integer math - you've been warned. If the rate style is random, a random number is generated to determine whether the fault is inserted with a probability of 0.2.

    """


    class MetaOapg:
        
        class properties:
            skipFor = schemas.IntSchema
            insert = schemas.IntSchema
            rate = schemas.IntSchema
            
            
            class rateStyle(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "fixed": "FIXED",
                        "random": "RANDOM",
                    }
                
                @schemas.classproperty
                def FIXED(cls):
                    return cls("fixed")
                
                @schemas.classproperty
                def RANDOM(cls):
                    return cls("random")
            __annotations__ = {
                "skipFor": skipFor,
                "insert": insert,
                "rate": rate,
                "rateStyle": rateStyle,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["skipFor"]) -> MetaOapg.properties.skipFor: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["insert"]) -> MetaOapg.properties.insert: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rate"]) -> MetaOapg.properties.rate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rateStyle"]) -> MetaOapg.properties.rateStyle: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["skipFor", "insert", "rate", "rateStyle", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["skipFor"]) -> typing.Union[MetaOapg.properties.skipFor, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["insert"]) -> typing.Union[MetaOapg.properties.insert, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rate"]) -> typing.Union[MetaOapg.properties.rate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rateStyle"]) -> typing.Union[MetaOapg.properties.rateStyle, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["skipFor", "insert", "rate", "rateStyle", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        skipFor: typing.Union[MetaOapg.properties.skipFor, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        insert: typing.Union[MetaOapg.properties.insert, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        rate: typing.Union[MetaOapg.properties.rate, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        rateStyle: typing.Union[MetaOapg.properties.rateStyle, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ConfigFaultCountedModel':
        return super().__new__(
            cls,
            *_args,
            skipFor=skipFor,
            insert=insert,
            rate=rate,
            rateStyle=rateStyle,
            _configuration=_configuration,
            **kwargs,
        )
