# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class ConfigModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    There are three types of configurations: faults, parameters, and logging. Due to the way swagger works, we make a property for each type, but only the property that matches the type enumeration will be processed.

    """


    class MetaOapg:
        
        class properties:
            name = schemas.StrSchema
            
            
            class configType(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "fault": "FAULT",
                        "parameter": "PARAMETER",
                        "logging": "LOGGING",
                    }
                
                @schemas.classproperty
                def FAULT(cls):
                    return cls("fault")
                
                @schemas.classproperty
                def PARAMETER(cls):
                    return cls("parameter")
                
                @schemas.classproperty
                def LOGGING(cls):
                    return cls("logging")
        
            @staticmethod
            def fault() -> typing.Type['ConfigFaultModel']:
                return ConfigFaultModel
        
            @staticmethod
            def parameter() -> typing.Type['ConfigParameterModel']:
                return ConfigParameterModel
            __annotations__ = {
                "name": name,
                "configType": configType,
                "fault": fault,
                "parameter": parameter,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["configType"]) -> MetaOapg.properties.configType: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fault"]) -> 'ConfigFaultModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["parameter"]) -> 'ConfigParameterModel': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["name", "configType", "fault", "parameter", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> typing.Union[MetaOapg.properties.name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["configType"]) -> typing.Union[MetaOapg.properties.configType, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fault"]) -> typing.Union['ConfigFaultModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["parameter"]) -> typing.Union['ConfigParameterModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["name", "configType", "fault", "parameter", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        name: typing.Union[MetaOapg.properties.name, str, schemas.Unset] = schemas.unset,
        configType: typing.Union[MetaOapg.properties.configType, str, schemas.Unset] = schemas.unset,
        fault: typing.Union['ConfigFaultModel', schemas.Unset] = schemas.unset,
        parameter: typing.Union['ConfigParameterModel', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'ConfigModel':
        return super().__new__(
            cls,
            *_args,
            name=name,
            configType=configType,
            fault=fault,
            parameter=parameter,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.config_fault_model import ConfigFaultModel
from data_repo_client.model.config_parameter_model import ConfigParameterModel
