# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DataDeletionRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    a container holding a specification for how to delete tabular data in one or more tables

    """


    class MetaOapg:
        required = {
            "specType",
            "deleteType",
        }
        
        class properties:
            
            
            class deleteType(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "soft": "SOFT",
                    }
                
                @schemas.classproperty
                def SOFT(cls):
                    return cls("soft")
            
            
            class specType(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "gcsFile": "GCS_FILE",
                        "jsonArray": "JSON_ARRAY",
                    }
                
                @schemas.classproperty
                def GCS_FILE(cls):
                    return cls("gcsFile")
                
                @schemas.classproperty
                def JSON_ARRAY(cls):
                    return cls("jsonArray")
            transactionId = schemas.UUIDSchema
            
            
            class tables(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['DataDeletionTableModel']:
                        return DataDeletionTableModel
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['DataDeletionTableModel'], typing.List['DataDeletionTableModel']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'tables':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'DataDeletionTableModel':
                    return super().__getitem__(i)
            __annotations__ = {
                "deleteType": deleteType,
                "specType": specType,
                "transactionId": transactionId,
                "tables": tables,
            }
    
    specType: MetaOapg.properties.specType
    deleteType: MetaOapg.properties.deleteType
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["deleteType"]) -> MetaOapg.properties.deleteType: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["specType"]) -> MetaOapg.properties.specType: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["transactionId"]) -> MetaOapg.properties.transactionId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tables"]) -> MetaOapg.properties.tables: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["deleteType", "specType", "transactionId", "tables", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["deleteType"]) -> MetaOapg.properties.deleteType: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["specType"]) -> MetaOapg.properties.specType: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["transactionId"]) -> typing.Union[MetaOapg.properties.transactionId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tables"]) -> typing.Union[MetaOapg.properties.tables, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["deleteType", "specType", "transactionId", "tables", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        specType: typing.Union[MetaOapg.properties.specType, str, ],
        deleteType: typing.Union[MetaOapg.properties.deleteType, str, ],
        transactionId: typing.Union[MetaOapg.properties.transactionId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        tables: typing.Union[MetaOapg.properties.tables, list, tuple, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DataDeletionRequest':
        return super().__new__(
            cls,
            *_args,
            specType=specType,
            deleteType=deleteType,
            transactionId=transactionId,
            tables=tables,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.data_deletion_table_model import DataDeletionTableModel
