# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DataDeletionTableModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    a specification for how to delete tabular data in one table

    """


    class MetaOapg:
        required = {
            "tableName",
        }
        
        class properties:
            tableName = schemas.StrSchema
        
            @staticmethod
            def gcsFileSpec() -> typing.Type['DataDeletionGcsFileModel']:
                return DataDeletionGcsFileModel
        
            @staticmethod
            def jsonArraySpec() -> typing.Type['DataDeletionJsonArrayModel']:
                return DataDeletionJsonArrayModel
            __annotations__ = {
                "tableName": tableName,
                "gcsFileSpec": gcsFileSpec,
                "jsonArraySpec": jsonArraySpec,
            }
    
    tableName: MetaOapg.properties.tableName
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tableName"]) -> MetaOapg.properties.tableName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["gcsFileSpec"]) -> 'DataDeletionGcsFileModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["jsonArraySpec"]) -> 'DataDeletionJsonArrayModel': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["tableName", "gcsFileSpec", "jsonArraySpec", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tableName"]) -> MetaOapg.properties.tableName: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["gcsFileSpec"]) -> typing.Union['DataDeletionGcsFileModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["jsonArraySpec"]) -> typing.Union['DataDeletionJsonArrayModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["tableName", "gcsFileSpec", "jsonArraySpec", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        tableName: typing.Union[MetaOapg.properties.tableName, str, ],
        gcsFileSpec: typing.Union['DataDeletionGcsFileModel', schemas.Unset] = schemas.unset,
        jsonArraySpec: typing.Union['DataDeletionJsonArrayModel', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DataDeletionTableModel':
        return super().__new__(
            cls,
            *_args,
            tableName=tableName,
            gcsFileSpec=gcsFileSpec,
            jsonArraySpec=jsonArraySpec,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.data_deletion_gcs_file_model import DataDeletionGcsFileModel
from data_repo_client.model.data_deletion_json_array_model import DataDeletionJsonArrayModel
