# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DatasetModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Complete definition of a dataset.

    """


    class MetaOapg:
        
        class properties:
            id = schemas.UUIDSchema
        
            @staticmethod
            def name() -> typing.Type['DatasetSnapshotNameProperty']:
                return DatasetSnapshotNameProperty
            description = schemas.StrSchema
            defaultProfileId = schemas.UUIDSchema
            dataProject = schemas.StrSchema
            defaultSnapshotId = schemas.StrSchema
        
            @staticmethod
            def schema() -> typing.Type['DatasetSpecificationModel']:
                return DatasetSpecificationModel
            createdDate = schemas.StrSchema
            
            
            class storage(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['StorageResourceModel']:
                        return StorageResourceModel
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['StorageResourceModel'], typing.List['StorageResourceModel']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'storage':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'StorageResourceModel':
                    return super().__getitem__(i)
            secureMonitoringEnabled = schemas.BoolSchema
            phsId = schemas.StrSchema
        
            @staticmethod
            def accessInformation() -> typing.Type['AccessInfoModel']:
                return AccessInfoModel
        
            @staticmethod
            def cloudPlatform() -> typing.Type['CloudPlatform']:
                return CloudPlatform
            selfHosted = schemas.BoolSchema
            properties = schemas.DictSchema
            ingestServiceAccount = schemas.StrSchema
            predictableFileIds = schemas.BoolSchema
            
            
            class tags(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    items = schemas.StrSchema
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, str, ]], typing.List[typing.Union[MetaOapg.items, str, ]]],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'tags':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> MetaOapg.items:
                    return super().__getitem__(i)
            __annotations__ = {
                "id": id,
                "name": name,
                "description": description,
                "defaultProfileId": defaultProfileId,
                "dataProject": dataProject,
                "defaultSnapshotId": defaultSnapshotId,
                "schema": schema,
                "createdDate": createdDate,
                "storage": storage,
                "secureMonitoringEnabled": secureMonitoringEnabled,
                "phsId": phsId,
                "accessInformation": accessInformation,
                "cloudPlatform": cloudPlatform,
                "selfHosted": selfHosted,
                "properties": properties,
                "ingestServiceAccount": ingestServiceAccount,
                "predictableFileIds": predictableFileIds,
                "tags": tags,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> 'DatasetSnapshotNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["defaultProfileId"]) -> MetaOapg.properties.defaultProfileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dataProject"]) -> MetaOapg.properties.dataProject: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["defaultSnapshotId"]) -> MetaOapg.properties.defaultSnapshotId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["schema"]) -> 'DatasetSpecificationModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["createdDate"]) -> MetaOapg.properties.createdDate: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["storage"]) -> MetaOapg.properties.storage: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["secureMonitoringEnabled"]) -> MetaOapg.properties.secureMonitoringEnabled: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["phsId"]) -> MetaOapg.properties.phsId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["accessInformation"]) -> 'AccessInfoModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["cloudPlatform"]) -> 'CloudPlatform': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["selfHosted"]) -> MetaOapg.properties.selfHosted: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["properties"]) -> MetaOapg.properties.properties: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["ingestServiceAccount"]) -> MetaOapg.properties.ingestServiceAccount: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["predictableFileIds"]) -> MetaOapg.properties.predictableFileIds: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tags"]) -> MetaOapg.properties.tags: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "name", "description", "defaultProfileId", "dataProject", "defaultSnapshotId", "schema", "createdDate", "storage", "secureMonitoringEnabled", "phsId", "accessInformation", "cloudPlatform", "selfHosted", "properties", "ingestServiceAccount", "predictableFileIds", "tags", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> typing.Union['DatasetSnapshotNameProperty', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["defaultProfileId"]) -> typing.Union[MetaOapg.properties.defaultProfileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dataProject"]) -> typing.Union[MetaOapg.properties.dataProject, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["defaultSnapshotId"]) -> typing.Union[MetaOapg.properties.defaultSnapshotId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["schema"]) -> typing.Union['DatasetSpecificationModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["createdDate"]) -> typing.Union[MetaOapg.properties.createdDate, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["storage"]) -> typing.Union[MetaOapg.properties.storage, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["secureMonitoringEnabled"]) -> typing.Union[MetaOapg.properties.secureMonitoringEnabled, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["phsId"]) -> typing.Union[MetaOapg.properties.phsId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["accessInformation"]) -> typing.Union['AccessInfoModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["cloudPlatform"]) -> typing.Union['CloudPlatform', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["selfHosted"]) -> typing.Union[MetaOapg.properties.selfHosted, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["properties"]) -> typing.Union[MetaOapg.properties.properties, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["ingestServiceAccount"]) -> typing.Union[MetaOapg.properties.ingestServiceAccount, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["predictableFileIds"]) -> typing.Union[MetaOapg.properties.predictableFileIds, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tags"]) -> typing.Union[MetaOapg.properties.tags, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "name", "description", "defaultProfileId", "dataProject", "defaultSnapshotId", "schema", "createdDate", "storage", "secureMonitoringEnabled", "phsId", "accessInformation", "cloudPlatform", "selfHosted", "properties", "ingestServiceAccount", "predictableFileIds", "tags", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        name: typing.Union['DatasetSnapshotNameProperty', schemas.Unset] = schemas.unset,
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        defaultProfileId: typing.Union[MetaOapg.properties.defaultProfileId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        dataProject: typing.Union[MetaOapg.properties.dataProject, str, schemas.Unset] = schemas.unset,
        defaultSnapshotId: typing.Union[MetaOapg.properties.defaultSnapshotId, str, schemas.Unset] = schemas.unset,
        schema: typing.Union['DatasetSpecificationModel', schemas.Unset] = schemas.unset,
        createdDate: typing.Union[MetaOapg.properties.createdDate, str, schemas.Unset] = schemas.unset,
        storage: typing.Union[MetaOapg.properties.storage, list, tuple, schemas.Unset] = schemas.unset,
        secureMonitoringEnabled: typing.Union[MetaOapg.properties.secureMonitoringEnabled, bool, schemas.Unset] = schemas.unset,
        phsId: typing.Union[MetaOapg.properties.phsId, str, schemas.Unset] = schemas.unset,
        accessInformation: typing.Union['AccessInfoModel', schemas.Unset] = schemas.unset,
        cloudPlatform: typing.Union['CloudPlatform', schemas.Unset] = schemas.unset,
        selfHosted: typing.Union[MetaOapg.properties.selfHosted, bool, schemas.Unset] = schemas.unset,
        properties: typing.Union[MetaOapg.properties.properties, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        ingestServiceAccount: typing.Union[MetaOapg.properties.ingestServiceAccount, str, schemas.Unset] = schemas.unset,
        predictableFileIds: typing.Union[MetaOapg.properties.predictableFileIds, bool, schemas.Unset] = schemas.unset,
        tags: typing.Union[MetaOapg.properties.tags, list, tuple, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DatasetModel':
        return super().__new__(
            cls,
            *_args,
            id=id,
            name=name,
            description=description,
            defaultProfileId=defaultProfileId,
            dataProject=dataProject,
            defaultSnapshotId=defaultSnapshotId,
            schema=schema,
            createdDate=createdDate,
            storage=storage,
            secureMonitoringEnabled=secureMonitoringEnabled,
            phsId=phsId,
            accessInformation=accessInformation,
            cloudPlatform=cloudPlatform,
            selfHosted=selfHosted,
            properties=properties,
            ingestServiceAccount=ingestServiceAccount,
            predictableFileIds=predictableFileIds,
            tags=tags,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.access_info_model import AccessInfoModel
from data_repo_client.model.cloud_platform import CloudPlatform
from data_repo_client.model.dataset_snapshot_name_property import DatasetSnapshotNameProperty
from data_repo_client.model.dataset_specification_model import DatasetSpecificationModel
from data_repo_client.model.storage_resource_model import StorageResourceModel
