# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DatasetRequestModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Complete definition of a dataset without the id (used to create a dataset)

    """


    class MetaOapg:
        required = {
            "schema",
            "defaultProfileId",
            "name",
        }
        
        class properties:
        
            @staticmethod
            def name() -> typing.Type['DatasetSnapshotNameProperty']:
                return DatasetSnapshotNameProperty
            defaultProfileId = schemas.UUIDSchema
        
            @staticmethod
            def schema() -> typing.Type['DatasetSpecificationModel']:
                return DatasetSpecificationModel
            description = schemas.StrSchema
            region = schemas.StrSchema
        
            @staticmethod
            def cloudPlatform() -> typing.Type['CloudPlatform']:
                return CloudPlatform
            enableSecureMonitoring = schemas.BoolSchema
            phsId = schemas.StrSchema
            experimentalSelfHosted = schemas.BoolSchema
            properties = schemas.DictSchema
            dedicatedIngestServiceAccount = schemas.BoolSchema
            experimentalPredictableFileIds = schemas.BoolSchema
            
            
            class policies(
                schemas.DictSchema
            ):
            
            
                class MetaOapg:
                    
                    class properties:
                        
                        
                        class stewards(
                            schemas.ListSchema
                        ):
                        
                        
                            class MetaOapg:
                                items = schemas.StrSchema
                        
                            def __new__(
                                cls,
                                _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, str, ]], typing.List[typing.Union[MetaOapg.items, str, ]]],
                                _configuration: typing.Optional[schemas.Configuration] = None,
                            ) -> 'stewards':
                                return super().__new__(
                                    cls,
                                    _arg,
                                    _configuration=_configuration,
                                )
                        
                            def __getitem__(self, i: int) -> MetaOapg.items:
                                return super().__getitem__(i)
                        
                        
                        class custodians(
                            schemas.ListSchema
                        ):
                        
                        
                            class MetaOapg:
                                items = schemas.StrSchema
                        
                            def __new__(
                                cls,
                                _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, str, ]], typing.List[typing.Union[MetaOapg.items, str, ]]],
                                _configuration: typing.Optional[schemas.Configuration] = None,
                            ) -> 'custodians':
                                return super().__new__(
                                    cls,
                                    _arg,
                                    _configuration=_configuration,
                                )
                        
                            def __getitem__(self, i: int) -> MetaOapg.items:
                                return super().__getitem__(i)
                        
                        
                        class snapshotCreators(
                            schemas.ListSchema
                        ):
                        
                        
                            class MetaOapg:
                                items = schemas.StrSchema
                        
                            def __new__(
                                cls,
                                _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, str, ]], typing.List[typing.Union[MetaOapg.items, str, ]]],
                                _configuration: typing.Optional[schemas.Configuration] = None,
                            ) -> 'snapshotCreators':
                                return super().__new__(
                                    cls,
                                    _arg,
                                    _configuration=_configuration,
                                )
                        
                            def __getitem__(self, i: int) -> MetaOapg.items:
                                return super().__getitem__(i)
                        __annotations__ = {
                            "stewards": stewards,
                            "custodians": custodians,
                            "snapshotCreators": snapshotCreators,
                        }
                
                @typing.overload
                def __getitem__(self, name: typing_extensions.Literal["stewards"]) -> MetaOapg.properties.stewards: ...
                
                @typing.overload
                def __getitem__(self, name: typing_extensions.Literal["custodians"]) -> MetaOapg.properties.custodians: ...
                
                @typing.overload
                def __getitem__(self, name: typing_extensions.Literal["snapshotCreators"]) -> MetaOapg.properties.snapshotCreators: ...
                
                @typing.overload
                def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
                
                def __getitem__(self, name: typing.Union[typing_extensions.Literal["stewards", "custodians", "snapshotCreators", ], str]):
                    # dict_instance[name] accessor
                    return super().__getitem__(name)
                
                
                @typing.overload
                def get_item_oapg(self, name: typing_extensions.Literal["stewards"]) -> typing.Union[MetaOapg.properties.stewards, schemas.Unset]: ...
                
                @typing.overload
                def get_item_oapg(self, name: typing_extensions.Literal["custodians"]) -> typing.Union[MetaOapg.properties.custodians, schemas.Unset]: ...
                
                @typing.overload
                def get_item_oapg(self, name: typing_extensions.Literal["snapshotCreators"]) -> typing.Union[MetaOapg.properties.snapshotCreators, schemas.Unset]: ...
                
                @typing.overload
                def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
                
                def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["stewards", "custodians", "snapshotCreators", ], str]):
                    return super().get_item_oapg(name)
                
            
                def __new__(
                    cls,
                    *_args: typing.Union[dict, frozendict.frozendict, ],
                    stewards: typing.Union[MetaOapg.properties.stewards, list, tuple, schemas.Unset] = schemas.unset,
                    custodians: typing.Union[MetaOapg.properties.custodians, list, tuple, schemas.Unset] = schemas.unset,
                    snapshotCreators: typing.Union[MetaOapg.properties.snapshotCreators, list, tuple, schemas.Unset] = schemas.unset,
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
                ) -> 'policies':
                    return super().__new__(
                        cls,
                        *_args,
                        stewards=stewards,
                        custodians=custodians,
                        snapshotCreators=snapshotCreators,
                        _configuration=_configuration,
                        **kwargs,
                    )
        
            @staticmethod
            def tags() -> typing.Type['ResourceCreateTags']:
                return ResourceCreateTags
            __annotations__ = {
                "name": name,
                "defaultProfileId": defaultProfileId,
                "schema": schema,
                "description": description,
                "region": region,
                "cloudPlatform": cloudPlatform,
                "enableSecureMonitoring": enableSecureMonitoring,
                "phsId": phsId,
                "experimentalSelfHosted": experimentalSelfHosted,
                "properties": properties,
                "dedicatedIngestServiceAccount": dedicatedIngestServiceAccount,
                "experimentalPredictableFileIds": experimentalPredictableFileIds,
                "policies": policies,
                "tags": tags,
            }
    
    schema: 'DatasetSpecificationModel'
    defaultProfileId: MetaOapg.properties.defaultProfileId
    name: 'DatasetSnapshotNameProperty'
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> 'DatasetSnapshotNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["defaultProfileId"]) -> MetaOapg.properties.defaultProfileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["schema"]) -> 'DatasetSpecificationModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["region"]) -> MetaOapg.properties.region: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["cloudPlatform"]) -> 'CloudPlatform': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["enableSecureMonitoring"]) -> MetaOapg.properties.enableSecureMonitoring: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["phsId"]) -> MetaOapg.properties.phsId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["experimentalSelfHosted"]) -> MetaOapg.properties.experimentalSelfHosted: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["properties"]) -> MetaOapg.properties.properties: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dedicatedIngestServiceAccount"]) -> MetaOapg.properties.dedicatedIngestServiceAccount: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["experimentalPredictableFileIds"]) -> MetaOapg.properties.experimentalPredictableFileIds: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["policies"]) -> MetaOapg.properties.policies: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tags"]) -> 'ResourceCreateTags': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["name", "defaultProfileId", "schema", "description", "region", "cloudPlatform", "enableSecureMonitoring", "phsId", "experimentalSelfHosted", "properties", "dedicatedIngestServiceAccount", "experimentalPredictableFileIds", "policies", "tags", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> 'DatasetSnapshotNameProperty': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["defaultProfileId"]) -> MetaOapg.properties.defaultProfileId: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["schema"]) -> 'DatasetSpecificationModel': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["region"]) -> typing.Union[MetaOapg.properties.region, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["cloudPlatform"]) -> typing.Union['CloudPlatform', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["enableSecureMonitoring"]) -> typing.Union[MetaOapg.properties.enableSecureMonitoring, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["phsId"]) -> typing.Union[MetaOapg.properties.phsId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["experimentalSelfHosted"]) -> typing.Union[MetaOapg.properties.experimentalSelfHosted, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["properties"]) -> typing.Union[MetaOapg.properties.properties, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dedicatedIngestServiceAccount"]) -> typing.Union[MetaOapg.properties.dedicatedIngestServiceAccount, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["experimentalPredictableFileIds"]) -> typing.Union[MetaOapg.properties.experimentalPredictableFileIds, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["policies"]) -> typing.Union[MetaOapg.properties.policies, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tags"]) -> typing.Union['ResourceCreateTags', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["name", "defaultProfileId", "schema", "description", "region", "cloudPlatform", "enableSecureMonitoring", "phsId", "experimentalSelfHosted", "properties", "dedicatedIngestServiceAccount", "experimentalPredictableFileIds", "policies", "tags", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        schema: 'DatasetSpecificationModel',
        defaultProfileId: typing.Union[MetaOapg.properties.defaultProfileId, str, uuid.UUID, ],
        name: 'DatasetSnapshotNameProperty',
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        region: typing.Union[MetaOapg.properties.region, str, schemas.Unset] = schemas.unset,
        cloudPlatform: typing.Union['CloudPlatform', schemas.Unset] = schemas.unset,
        enableSecureMonitoring: typing.Union[MetaOapg.properties.enableSecureMonitoring, bool, schemas.Unset] = schemas.unset,
        phsId: typing.Union[MetaOapg.properties.phsId, str, schemas.Unset] = schemas.unset,
        experimentalSelfHosted: typing.Union[MetaOapg.properties.experimentalSelfHosted, bool, schemas.Unset] = schemas.unset,
        properties: typing.Union[MetaOapg.properties.properties, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        dedicatedIngestServiceAccount: typing.Union[MetaOapg.properties.dedicatedIngestServiceAccount, bool, schemas.Unset] = schemas.unset,
        experimentalPredictableFileIds: typing.Union[MetaOapg.properties.experimentalPredictableFileIds, bool, schemas.Unset] = schemas.unset,
        policies: typing.Union[MetaOapg.properties.policies, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        tags: typing.Union['ResourceCreateTags', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DatasetRequestModel':
        return super().__new__(
            cls,
            *_args,
            schema=schema,
            defaultProfileId=defaultProfileId,
            name=name,
            description=description,
            region=region,
            cloudPlatform=cloudPlatform,
            enableSecureMonitoring=enableSecureMonitoring,
            phsId=phsId,
            experimentalSelfHosted=experimentalSelfHosted,
            properties=properties,
            dedicatedIngestServiceAccount=dedicatedIngestServiceAccount,
            experimentalPredictableFileIds=experimentalPredictableFileIds,
            policies=policies,
            tags=tags,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.cloud_platform import CloudPlatform
from data_repo_client.model.dataset_snapshot_name_property import DatasetSnapshotNameProperty
from data_repo_client.model.dataset_specification_model import DatasetSpecificationModel
from data_repo_client.model.resource_create_tags import ResourceCreateTags
