# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DatasetSchemaUpdateModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        
        class properties:
            description = schemas.StrSchema
            
            
            class changes(
                schemas.DictSchema
            ):
            
            
                class MetaOapg:
                    
                    class properties:
                        
                        
                        class addTables(
                            schemas.ListSchema
                        ):
                        
                        
                            class MetaOapg:
                                
                                @staticmethod
                                def items() -> typing.Type['TableModel']:
                                    return TableModel
                        
                            def __new__(
                                cls,
                                _arg: typing.Union[typing.Tuple['TableModel'], typing.List['TableModel']],
                                _configuration: typing.Optional[schemas.Configuration] = None,
                            ) -> 'addTables':
                                return super().__new__(
                                    cls,
                                    _arg,
                                    _configuration=_configuration,
                                )
                        
                            def __getitem__(self, i: int) -> 'TableModel':
                                return super().__getitem__(i)
                        
                        
                        class addColumns(
                            schemas.ListSchema
                        ):
                        
                        
                            class MetaOapg:
                                
                                @staticmethod
                                def items() -> typing.Type['DatasetSchemaColumnUpdateModel']:
                                    return DatasetSchemaColumnUpdateModel
                        
                            def __new__(
                                cls,
                                _arg: typing.Union[typing.Tuple['DatasetSchemaColumnUpdateModel'], typing.List['DatasetSchemaColumnUpdateModel']],
                                _configuration: typing.Optional[schemas.Configuration] = None,
                            ) -> 'addColumns':
                                return super().__new__(
                                    cls,
                                    _arg,
                                    _configuration=_configuration,
                                )
                        
                            def __getitem__(self, i: int) -> 'DatasetSchemaColumnUpdateModel':
                                return super().__getitem__(i)
                        
                        
                        class addRelationships(
                            schemas.ListSchema
                        ):
                        
                        
                            class MetaOapg:
                                
                                @staticmethod
                                def items() -> typing.Type['RelationshipModel']:
                                    return RelationshipModel
                        
                            def __new__(
                                cls,
                                _arg: typing.Union[typing.Tuple['RelationshipModel'], typing.List['RelationshipModel']],
                                _configuration: typing.Optional[schemas.Configuration] = None,
                            ) -> 'addRelationships':
                                return super().__new__(
                                    cls,
                                    _arg,
                                    _configuration=_configuration,
                                )
                        
                            def __getitem__(self, i: int) -> 'RelationshipModel':
                                return super().__getitem__(i)
                        __annotations__ = {
                            "addTables": addTables,
                            "addColumns": addColumns,
                            "addRelationships": addRelationships,
                        }
                
                @typing.overload
                def __getitem__(self, name: typing_extensions.Literal["addTables"]) -> MetaOapg.properties.addTables: ...
                
                @typing.overload
                def __getitem__(self, name: typing_extensions.Literal["addColumns"]) -> MetaOapg.properties.addColumns: ...
                
                @typing.overload
                def __getitem__(self, name: typing_extensions.Literal["addRelationships"]) -> MetaOapg.properties.addRelationships: ...
                
                @typing.overload
                def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
                
                def __getitem__(self, name: typing.Union[typing_extensions.Literal["addTables", "addColumns", "addRelationships", ], str]):
                    # dict_instance[name] accessor
                    return super().__getitem__(name)
                
                
                @typing.overload
                def get_item_oapg(self, name: typing_extensions.Literal["addTables"]) -> typing.Union[MetaOapg.properties.addTables, schemas.Unset]: ...
                
                @typing.overload
                def get_item_oapg(self, name: typing_extensions.Literal["addColumns"]) -> typing.Union[MetaOapg.properties.addColumns, schemas.Unset]: ...
                
                @typing.overload
                def get_item_oapg(self, name: typing_extensions.Literal["addRelationships"]) -> typing.Union[MetaOapg.properties.addRelationships, schemas.Unset]: ...
                
                @typing.overload
                def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
                
                def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["addTables", "addColumns", "addRelationships", ], str]):
                    return super().get_item_oapg(name)
                
            
                def __new__(
                    cls,
                    *_args: typing.Union[dict, frozendict.frozendict, ],
                    addTables: typing.Union[MetaOapg.properties.addTables, list, tuple, schemas.Unset] = schemas.unset,
                    addColumns: typing.Union[MetaOapg.properties.addColumns, list, tuple, schemas.Unset] = schemas.unset,
                    addRelationships: typing.Union[MetaOapg.properties.addRelationships, list, tuple, schemas.Unset] = schemas.unset,
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
                ) -> 'changes':
                    return super().__new__(
                        cls,
                        *_args,
                        addTables=addTables,
                        addColumns=addColumns,
                        addRelationships=addRelationships,
                        _configuration=_configuration,
                        **kwargs,
                    )
            __annotations__ = {
                "description": description,
                "changes": changes,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["changes"]) -> MetaOapg.properties.changes: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["description", "changes", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["changes"]) -> typing.Union[MetaOapg.properties.changes, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["description", "changes", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        changes: typing.Union[MetaOapg.properties.changes, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DatasetSchemaUpdateModel':
        return super().__new__(
            cls,
            *_args,
            description=description,
            changes=changes,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.dataset_schema_column_update_model import DatasetSchemaColumnUpdateModel
from data_repo_client.model.relationship_model import RelationshipModel
from data_repo_client.model.table_model import TableModel
