# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DRSAccessMethod(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "type",
        }
        
        class properties:
            
            
            class type(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "s3": "S3",
                        "gs": "GS",
                        "ftp": "FTP",
                        "gsiftp": "GSIFTP",
                        "globus": "GLOBUS",
                        "htsget": "HTSGET",
                        "https": "HTTPS",
                        "file": "FILE",
                    }
                
                @schemas.classproperty
                def S3(cls):
                    return cls("s3")
                
                @schemas.classproperty
                def GS(cls):
                    return cls("gs")
                
                @schemas.classproperty
                def FTP(cls):
                    return cls("ftp")
                
                @schemas.classproperty
                def GSIFTP(cls):
                    return cls("gsiftp")
                
                @schemas.classproperty
                def GLOBUS(cls):
                    return cls("globus")
                
                @schemas.classproperty
                def HTSGET(cls):
                    return cls("htsget")
                
                @schemas.classproperty
                def HTTPS(cls):
                    return cls("https")
                
                @schemas.classproperty
                def FILE(cls):
                    return cls("file")
        
            @staticmethod
            def access_url() -> typing.Type['DRSAccessURL']:
                return DRSAccessURL
            access_id = schemas.StrSchema
            region = schemas.StrSchema
        
            @staticmethod
            def authorizations() -> typing.Type['DRSAuthorizations']:
                return DRSAuthorizations
            __annotations__ = {
                "type": type,
                "access_url": access_url,
                "access_id": access_id,
                "region": region,
                "authorizations": authorizations,
            }
    
    type: MetaOapg.properties.type
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["access_url"]) -> 'DRSAccessURL': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["access_id"]) -> MetaOapg.properties.access_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["region"]) -> MetaOapg.properties.region: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["authorizations"]) -> 'DRSAuthorizations': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["type", "access_url", "access_id", "region", "authorizations", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["access_url"]) -> typing.Union['DRSAccessURL', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["access_id"]) -> typing.Union[MetaOapg.properties.access_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["region"]) -> typing.Union[MetaOapg.properties.region, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["authorizations"]) -> typing.Union['DRSAuthorizations', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["type", "access_url", "access_id", "region", "authorizations", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        type: typing.Union[MetaOapg.properties.type, str, ],
        access_url: typing.Union['DRSAccessURL', schemas.Unset] = schemas.unset,
        access_id: typing.Union[MetaOapg.properties.access_id, str, schemas.Unset] = schemas.unset,
        region: typing.Union[MetaOapg.properties.region, str, schemas.Unset] = schemas.unset,
        authorizations: typing.Union['DRSAuthorizations', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DRSAccessMethod':
        return super().__new__(
            cls,
            *_args,
            type=type,
            access_url=access_url,
            access_id=access_id,
            region=region,
            authorizations=authorizations,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.drs_access_url import DRSAccessURL
from data_repo_client.model.drs_authorizations import DRSAuthorizations
