# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class DRSObject(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "checksums",
            "size",
            "id",
            "self_uri",
        }
        
        class properties:
            id = schemas.StrSchema
            self_uri = schemas.StrSchema
            size = schemas.Int64Schema
            
            
            class checksums(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    min_items = 1
                    
                    @staticmethod
                    def items() -> typing.Type['DRSChecksum']:
                        return DRSChecksum
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['DRSChecksum'], typing.List['DRSChecksum']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'checksums':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'DRSChecksum':
                    return super().__getitem__(i)
            name = schemas.StrSchema
            created_time = schemas.StrSchema
            updated_time = schemas.StrSchema
            version = schemas.StrSchema
            mime_type = schemas.StrSchema
            
            
            class access_methods(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    min_items = 1
                    
                    @staticmethod
                    def items() -> typing.Type['DRSAccessMethod']:
                        return DRSAccessMethod
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['DRSAccessMethod'], typing.List['DRSAccessMethod']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'access_methods':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'DRSAccessMethod':
                    return super().__getitem__(i)
            
            
            class contents(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['DRSContentsObject']:
                        return DRSContentsObject
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['DRSContentsObject'], typing.List['DRSContentsObject']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'contents':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'DRSContentsObject':
                    return super().__getitem__(i)
            description = schemas.StrSchema
            
            
            class aliases(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    items = schemas.StrSchema
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple[typing.Union[MetaOapg.items, str, ]], typing.List[typing.Union[MetaOapg.items, str, ]]],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'aliases':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> MetaOapg.items:
                    return super().__getitem__(i)
            __annotations__ = {
                "id": id,
                "self_uri": self_uri,
                "size": size,
                "checksums": checksums,
                "name": name,
                "created_time": created_time,
                "updated_time": updated_time,
                "version": version,
                "mime_type": mime_type,
                "access_methods": access_methods,
                "contents": contents,
                "description": description,
                "aliases": aliases,
            }
    
    checksums: MetaOapg.properties.checksums
    size: MetaOapg.properties.size
    id: MetaOapg.properties.id
    self_uri: MetaOapg.properties.self_uri
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["self_uri"]) -> MetaOapg.properties.self_uri: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["size"]) -> MetaOapg.properties.size: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["checksums"]) -> MetaOapg.properties.checksums: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["created_time"]) -> MetaOapg.properties.created_time: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["updated_time"]) -> MetaOapg.properties.updated_time: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["version"]) -> MetaOapg.properties.version: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["mime_type"]) -> MetaOapg.properties.mime_type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["access_methods"]) -> MetaOapg.properties.access_methods: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["contents"]) -> MetaOapg.properties.contents: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["aliases"]) -> MetaOapg.properties.aliases: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "self_uri", "size", "checksums", "name", "created_time", "updated_time", "version", "mime_type", "access_methods", "contents", "description", "aliases", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["self_uri"]) -> MetaOapg.properties.self_uri: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["size"]) -> MetaOapg.properties.size: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["checksums"]) -> MetaOapg.properties.checksums: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> typing.Union[MetaOapg.properties.name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["created_time"]) -> typing.Union[MetaOapg.properties.created_time, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["updated_time"]) -> typing.Union[MetaOapg.properties.updated_time, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["version"]) -> typing.Union[MetaOapg.properties.version, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["mime_type"]) -> typing.Union[MetaOapg.properties.mime_type, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["access_methods"]) -> typing.Union[MetaOapg.properties.access_methods, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["contents"]) -> typing.Union[MetaOapg.properties.contents, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["aliases"]) -> typing.Union[MetaOapg.properties.aliases, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "self_uri", "size", "checksums", "name", "created_time", "updated_time", "version", "mime_type", "access_methods", "contents", "description", "aliases", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        checksums: typing.Union[MetaOapg.properties.checksums, list, tuple, ],
        size: typing.Union[MetaOapg.properties.size, decimal.Decimal, int, ],
        id: typing.Union[MetaOapg.properties.id, str, ],
        self_uri: typing.Union[MetaOapg.properties.self_uri, str, ],
        name: typing.Union[MetaOapg.properties.name, str, schemas.Unset] = schemas.unset,
        created_time: typing.Union[MetaOapg.properties.created_time, str, schemas.Unset] = schemas.unset,
        updated_time: typing.Union[MetaOapg.properties.updated_time, str, schemas.Unset] = schemas.unset,
        version: typing.Union[MetaOapg.properties.version, str, schemas.Unset] = schemas.unset,
        mime_type: typing.Union[MetaOapg.properties.mime_type, str, schemas.Unset] = schemas.unset,
        access_methods: typing.Union[MetaOapg.properties.access_methods, list, tuple, schemas.Unset] = schemas.unset,
        contents: typing.Union[MetaOapg.properties.contents, list, tuple, schemas.Unset] = schemas.unset,
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        aliases: typing.Union[MetaOapg.properties.aliases, list, tuple, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'DRSObject':
        return super().__new__(
            cls,
            *_args,
            checksums=checksums,
            size=size,
            id=id,
            self_uri=self_uri,
            name=name,
            created_time=created_time,
            updated_time=updated_time,
            version=version,
            mime_type=mime_type,
            access_methods=access_methods,
            contents=contents,
            description=description,
            aliases=aliases,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.drs_access_method import DRSAccessMethod
from data_repo_client.model.drs_checksum import DRSChecksum
from data_repo_client.model.drs_contents_object import DRSContentsObject
