# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class FileLoadModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Information needed to copy a file from a source bucket into the dataset bucket. Eventually, this will include attributes of the storage including billing, temperature, geography, etc. But for now...

    """


    class MetaOapg:
        required = {
            "source_path",
            "target_path",
        }
        
        class properties:
            source_path = schemas.StrSchema
            target_path = schemas.StrSchema
            mime_type = schemas.StrSchema
            profileId = schemas.UUIDSchema
            loadTag = schemas.StrSchema
            description = schemas.StrSchema
            md5 = schemas.StrSchema
            __annotations__ = {
                "source_path": source_path,
                "target_path": target_path,
                "mime_type": mime_type,
                "profileId": profileId,
                "loadTag": loadTag,
                "description": description,
                "md5": md5,
            }
    
    source_path: MetaOapg.properties.source_path
    target_path: MetaOapg.properties.target_path
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["source_path"]) -> MetaOapg.properties.source_path: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["target_path"]) -> MetaOapg.properties.target_path: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["mime_type"]) -> MetaOapg.properties.mime_type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["profileId"]) -> MetaOapg.properties.profileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["loadTag"]) -> MetaOapg.properties.loadTag: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["md5"]) -> MetaOapg.properties.md5: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["source_path", "target_path", "mime_type", "profileId", "loadTag", "description", "md5", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["source_path"]) -> MetaOapg.properties.source_path: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["target_path"]) -> MetaOapg.properties.target_path: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["mime_type"]) -> typing.Union[MetaOapg.properties.mime_type, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["profileId"]) -> typing.Union[MetaOapg.properties.profileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["loadTag"]) -> typing.Union[MetaOapg.properties.loadTag, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["md5"]) -> typing.Union[MetaOapg.properties.md5, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["source_path", "target_path", "mime_type", "profileId", "loadTag", "description", "md5", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        source_path: typing.Union[MetaOapg.properties.source_path, str, ],
        target_path: typing.Union[MetaOapg.properties.target_path, str, ],
        mime_type: typing.Union[MetaOapg.properties.mime_type, str, schemas.Unset] = schemas.unset,
        profileId: typing.Union[MetaOapg.properties.profileId, str, uuid.UUID, schemas.Unset] = schemas.unset,
        loadTag: typing.Union[MetaOapg.properties.loadTag, str, schemas.Unset] = schemas.unset,
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        md5: typing.Union[MetaOapg.properties.md5, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'FileLoadModel':
        return super().__new__(
            cls,
            *_args,
            source_path=source_path,
            target_path=target_path,
            mime_type=mime_type,
            profileId=profileId,
            loadTag=loadTag,
            description=description,
            md5=md5,
            _configuration=_configuration,
            **kwargs,
        )
