# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class FileModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    A file or directory in the data repository
    """


    class MetaOapg:
        
        class properties:
            fileId = schemas.StrSchema
            collectionId = schemas.StrSchema
            path = schemas.StrSchema
            size = schemas.Int64Schema
            
            
            class checksums(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['DRSChecksum']:
                        return DRSChecksum
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['DRSChecksum'], typing.List['DRSChecksum']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'checksums':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'DRSChecksum':
                    return super().__getitem__(i)
            created = schemas.StrSchema
            description = schemas.StrSchema
        
            @staticmethod
            def fileType() -> typing.Type['FileModelType']:
                return FileModelType
        
            @staticmethod
            def fileDetail() -> typing.Type['FileDetailModel']:
                return FileDetailModel
        
            @staticmethod
            def directoryDetail() -> typing.Type['DirectoryDetailModel']:
                return DirectoryDetailModel
            __annotations__ = {
                "fileId": fileId,
                "collectionId": collectionId,
                "path": path,
                "size": size,
                "checksums": checksums,
                "created": created,
                "description": description,
                "fileType": fileType,
                "fileDetail": fileDetail,
                "directoryDetail": directoryDetail,
            }
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileId"]) -> MetaOapg.properties.fileId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["collectionId"]) -> MetaOapg.properties.collectionId: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["path"]) -> MetaOapg.properties.path: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["size"]) -> MetaOapg.properties.size: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["checksums"]) -> MetaOapg.properties.checksums: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["created"]) -> MetaOapg.properties.created: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileType"]) -> 'FileModelType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fileDetail"]) -> 'FileDetailModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["directoryDetail"]) -> 'DirectoryDetailModel': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["fileId", "collectionId", "path", "size", "checksums", "created", "description", "fileType", "fileDetail", "directoryDetail", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileId"]) -> typing.Union[MetaOapg.properties.fileId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["collectionId"]) -> typing.Union[MetaOapg.properties.collectionId, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["path"]) -> typing.Union[MetaOapg.properties.path, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["size"]) -> typing.Union[MetaOapg.properties.size, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["checksums"]) -> typing.Union[MetaOapg.properties.checksums, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["created"]) -> typing.Union[MetaOapg.properties.created, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileType"]) -> typing.Union['FileModelType', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fileDetail"]) -> typing.Union['FileDetailModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["directoryDetail"]) -> typing.Union['DirectoryDetailModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["fileId", "collectionId", "path", "size", "checksums", "created", "description", "fileType", "fileDetail", "directoryDetail", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        fileId: typing.Union[MetaOapg.properties.fileId, str, schemas.Unset] = schemas.unset,
        collectionId: typing.Union[MetaOapg.properties.collectionId, str, schemas.Unset] = schemas.unset,
        path: typing.Union[MetaOapg.properties.path, str, schemas.Unset] = schemas.unset,
        size: typing.Union[MetaOapg.properties.size, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        checksums: typing.Union[MetaOapg.properties.checksums, list, tuple, schemas.Unset] = schemas.unset,
        created: typing.Union[MetaOapg.properties.created, str, schemas.Unset] = schemas.unset,
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        fileType: typing.Union['FileModelType', schemas.Unset] = schemas.unset,
        fileDetail: typing.Union['FileDetailModel', schemas.Unset] = schemas.unset,
        directoryDetail: typing.Union['DirectoryDetailModel', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'FileModel':
        return super().__new__(
            cls,
            *_args,
            fileId=fileId,
            collectionId=collectionId,
            path=path,
            size=size,
            checksums=checksums,
            created=created,
            description=description,
            fileType=fileType,
            fileDetail=fileDetail,
            directoryDetail=directoryDetail,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.directory_detail_model import DirectoryDetailModel
from data_repo_client.model.drs_checksum import DRSChecksum
from data_repo_client.model.file_detail_model import FileDetailModel
from data_repo_client.model.file_model_type import FileModelType
