# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class IngestResponseModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Response from performing an ingest.

    """


    class MetaOapg:
        required = {
            "path",
            "table",
            "row_count",
        }
        
        class properties:
        
            @staticmethod
            def table() -> typing.Type['ObjectNameProperty']:
                return ObjectNameProperty
            path = schemas.StrSchema
            row_count = schemas.Int64Schema
            dataset_id = schemas.UUIDSchema
        
            @staticmethod
            def dataset() -> typing.Type['DatasetSnapshotNameProperty']:
                return DatasetSnapshotNameProperty
            load_tag = schemas.StrSchema
            bad_row_count = schemas.Int64Schema
        
            @staticmethod
            def load_result() -> typing.Type['BulkLoadArrayResultModel']:
                return BulkLoadArrayResultModel
            __annotations__ = {
                "table": table,
                "path": path,
                "row_count": row_count,
                "dataset_id": dataset_id,
                "dataset": dataset,
                "load_tag": load_tag,
                "bad_row_count": bad_row_count,
                "load_result": load_result,
            }
    
    path: MetaOapg.properties.path
    table: 'ObjectNameProperty'
    row_count: MetaOapg.properties.row_count
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["table"]) -> 'ObjectNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["path"]) -> MetaOapg.properties.path: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["row_count"]) -> MetaOapg.properties.row_count: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dataset_id"]) -> MetaOapg.properties.dataset_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dataset"]) -> 'DatasetSnapshotNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["load_tag"]) -> MetaOapg.properties.load_tag: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bad_row_count"]) -> MetaOapg.properties.bad_row_count: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["load_result"]) -> 'BulkLoadArrayResultModel': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["table", "path", "row_count", "dataset_id", "dataset", "load_tag", "bad_row_count", "load_result", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["table"]) -> 'ObjectNameProperty': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["path"]) -> MetaOapg.properties.path: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["row_count"]) -> MetaOapg.properties.row_count: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dataset_id"]) -> typing.Union[MetaOapg.properties.dataset_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dataset"]) -> typing.Union['DatasetSnapshotNameProperty', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["load_tag"]) -> typing.Union[MetaOapg.properties.load_tag, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bad_row_count"]) -> typing.Union[MetaOapg.properties.bad_row_count, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["load_result"]) -> typing.Union['BulkLoadArrayResultModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["table", "path", "row_count", "dataset_id", "dataset", "load_tag", "bad_row_count", "load_result", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        path: typing.Union[MetaOapg.properties.path, str, ],
        table: 'ObjectNameProperty',
        row_count: typing.Union[MetaOapg.properties.row_count, decimal.Decimal, int, ],
        dataset_id: typing.Union[MetaOapg.properties.dataset_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        dataset: typing.Union['DatasetSnapshotNameProperty', schemas.Unset] = schemas.unset,
        load_tag: typing.Union[MetaOapg.properties.load_tag, str, schemas.Unset] = schemas.unset,
        bad_row_count: typing.Union[MetaOapg.properties.bad_row_count, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        load_result: typing.Union['BulkLoadArrayResultModel', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'IngestResponseModel':
        return super().__new__(
            cls,
            *_args,
            path=path,
            table=table,
            row_count=row_count,
            dataset_id=dataset_id,
            dataset=dataset,
            load_tag=load_tag,
            bad_row_count=bad_row_count,
            load_result=load_result,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.bulk_load_array_result_model import BulkLoadArrayResultModel
from data_repo_client.model.dataset_snapshot_name_property import DatasetSnapshotNameProperty
from data_repo_client.model.object_name_property import ObjectNameProperty
