# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class JournalEntryModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "entryType",
            "resourceKey",
            "methodName",
            "className",
            "id",
            "user",
            "when",
            "resourceType",
        }
        
        class properties:
            id = schemas.UUIDSchema
            resourceKey = schemas.UUIDSchema
            user = schemas.StrSchema
        
            @staticmethod
            def resourceType() -> typing.Type['IamResourceTypeEnum']:
                return IamResourceTypeEnum
            className = schemas.StrSchema
            methodName = schemas.StrSchema
            
            
            class entryType(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "CREATE": "CREATE",
                        "UPDATE": "UPDATE",
                        "DELETE": "DELETE",
                    }
                
                @schemas.classproperty
                def CREATE(cls):
                    return cls("CREATE")
                
                @schemas.classproperty
                def UPDATE(cls):
                    return cls("UPDATE")
                
                @schemas.classproperty
                def DELETE(cls):
                    return cls("DELETE")
            when = schemas.StrSchema
            mutation = schemas.DictSchema
            note = schemas.StrSchema
            __annotations__ = {
                "id": id,
                "resourceKey": resourceKey,
                "user": user,
                "resourceType": resourceType,
                "className": className,
                "methodName": methodName,
                "entryType": entryType,
                "when": when,
                "mutation": mutation,
                "note": note,
            }
    
    entryType: MetaOapg.properties.entryType
    resourceKey: MetaOapg.properties.resourceKey
    methodName: MetaOapg.properties.methodName
    className: MetaOapg.properties.className
    id: MetaOapg.properties.id
    user: MetaOapg.properties.user
    when: MetaOapg.properties.when
    resourceType: 'IamResourceTypeEnum'
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["resourceKey"]) -> MetaOapg.properties.resourceKey: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["user"]) -> MetaOapg.properties.user: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["resourceType"]) -> 'IamResourceTypeEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["className"]) -> MetaOapg.properties.className: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["methodName"]) -> MetaOapg.properties.methodName: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["entryType"]) -> MetaOapg.properties.entryType: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["when"]) -> MetaOapg.properties.when: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["mutation"]) -> MetaOapg.properties.mutation: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["note"]) -> MetaOapg.properties.note: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "resourceKey", "user", "resourceType", "className", "methodName", "entryType", "when", "mutation", "note", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["resourceKey"]) -> MetaOapg.properties.resourceKey: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["user"]) -> MetaOapg.properties.user: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["resourceType"]) -> 'IamResourceTypeEnum': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["className"]) -> MetaOapg.properties.className: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["methodName"]) -> MetaOapg.properties.methodName: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["entryType"]) -> MetaOapg.properties.entryType: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["when"]) -> MetaOapg.properties.when: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["mutation"]) -> typing.Union[MetaOapg.properties.mutation, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["note"]) -> typing.Union[MetaOapg.properties.note, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "resourceKey", "user", "resourceType", "className", "methodName", "entryType", "when", "mutation", "note", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        entryType: typing.Union[MetaOapg.properties.entryType, str, ],
        resourceKey: typing.Union[MetaOapg.properties.resourceKey, str, uuid.UUID, ],
        methodName: typing.Union[MetaOapg.properties.methodName, str, ],
        className: typing.Union[MetaOapg.properties.className, str, ],
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, ],
        user: typing.Union[MetaOapg.properties.user, str, ],
        when: typing.Union[MetaOapg.properties.when, str, ],
        resourceType: 'IamResourceTypeEnum',
        mutation: typing.Union[MetaOapg.properties.mutation, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        note: typing.Union[MetaOapg.properties.note, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'JournalEntryModel':
        return super().__new__(
            cls,
            *_args,
            entryType=entryType,
            resourceKey=resourceKey,
            methodName=methodName,
            className=className,
            id=id,
            user=user,
            when=when,
            resourceType=resourceType,
            mutation=mutation,
            note=note,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.iam_resource_type_enum import IamResourceTypeEnum
