# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class SnapshotRequestContentsModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    The contents specifies the source of the data (dataset and asset) and the rows to include (field and rootValues). TODO: field will move the asset object; it is here as a stepping stone

    """


    class MetaOapg:
        required = {
            "mode",
            "datasetName",
        }
        
        class properties:
        
            @staticmethod
            def datasetName() -> typing.Type['DatasetSnapshotNameProperty']:
                return DatasetSnapshotNameProperty
            
            
            class mode(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "byAsset": "BY_ASSET",
                        "byFullView": "BY_FULL_VIEW",
                        "byQuery": "BY_QUERY",
                        "byRowId": "BY_ROW_ID",
                    }
                
                @schemas.classproperty
                def BY_ASSET(cls):
                    return cls("byAsset")
                
                @schemas.classproperty
                def BY_FULL_VIEW(cls):
                    return cls("byFullView")
                
                @schemas.classproperty
                def BY_QUERY(cls):
                    return cls("byQuery")
                
                @schemas.classproperty
                def BY_ROW_ID(cls):
                    return cls("byRowId")
        
            @staticmethod
            def assetSpec() -> typing.Type['SnapshotRequestAssetModel']:
                return SnapshotRequestAssetModel
        
            @staticmethod
            def querySpec() -> typing.Type['SnapshotRequestQueryModel']:
                return SnapshotRequestQueryModel
        
            @staticmethod
            def rowIdSpec() -> typing.Type['SnapshotRequestRowIdModel']:
                return SnapshotRequestRowIdModel
            __annotations__ = {
                "datasetName": datasetName,
                "mode": mode,
                "assetSpec": assetSpec,
                "querySpec": querySpec,
                "rowIdSpec": rowIdSpec,
            }
    
    mode: MetaOapg.properties.mode
    datasetName: 'DatasetSnapshotNameProperty'
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["datasetName"]) -> 'DatasetSnapshotNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["mode"]) -> MetaOapg.properties.mode: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["assetSpec"]) -> 'SnapshotRequestAssetModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["querySpec"]) -> 'SnapshotRequestQueryModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rowIdSpec"]) -> 'SnapshotRequestRowIdModel': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["datasetName", "mode", "assetSpec", "querySpec", "rowIdSpec", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["datasetName"]) -> 'DatasetSnapshotNameProperty': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["mode"]) -> MetaOapg.properties.mode: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["assetSpec"]) -> typing.Union['SnapshotRequestAssetModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["querySpec"]) -> typing.Union['SnapshotRequestQueryModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rowIdSpec"]) -> typing.Union['SnapshotRequestRowIdModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["datasetName", "mode", "assetSpec", "querySpec", "rowIdSpec", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        mode: typing.Union[MetaOapg.properties.mode, str, ],
        datasetName: 'DatasetSnapshotNameProperty',
        assetSpec: typing.Union['SnapshotRequestAssetModel', schemas.Unset] = schemas.unset,
        querySpec: typing.Union['SnapshotRequestQueryModel', schemas.Unset] = schemas.unset,
        rowIdSpec: typing.Union['SnapshotRequestRowIdModel', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'SnapshotRequestContentsModel':
        return super().__new__(
            cls,
            *_args,
            mode=mode,
            datasetName=datasetName,
            assetSpec=assetSpec,
            querySpec=querySpec,
            rowIdSpec=rowIdSpec,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.dataset_snapshot_name_property import DatasetSnapshotNameProperty
from data_repo_client.model.snapshot_request_asset_model import SnapshotRequestAssetModel
from data_repo_client.model.snapshot_request_query_model import SnapshotRequestQueryModel
from data_repo_client.model.snapshot_request_row_id_model import SnapshotRequestRowIdModel
