# coding: utf-8

"""
    Data Repository API

    <details><summary>This document defines the REST API for the Terra Data Repository.</summary> <p> **Status: design in progress** There are a few top-level endpoints (besides some used by swagger):  * / - generated by swagger: swagger API page that provides this documentation and a live UI for submitting REST requests  * /status - provides the operational status of the service  * /configuration - provides the basic configuration and information about the service  * /api - is the authenticated and authorized Data Repository API  * /ga4gh/drs/v1 - is a transcription of the Data Repository Service API  The API endpoints are organized by interface. Each interface is separately versioned. <p> **Notes on Naming** <p> All of the reference items are suffixed with \\\"Model\\\". Those names are used as the class names in the generated Java code. It is helpful to distinguish these model classes from other related classes, like the DAO classes and the operation classes. </details>   # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from data_repo_client import schemas  # noqa: F401


class TableModel(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    one table in a schema
    """


    class MetaOapg:
        required = {
            "columns",
            "name",
        }
        
        class properties:
        
            @staticmethod
            def name() -> typing.Type['ObjectNameProperty']:
                return ObjectNameProperty
            
            
            class columns(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['ColumnModel']:
                        return ColumnModel
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['ColumnModel'], typing.List['ColumnModel']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'columns':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'ColumnModel':
                    return super().__getitem__(i)
            
            
            class primaryKey(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    
                    @staticmethod
                    def items() -> typing.Type['ColumnNameProperty']:
                        return ColumnNameProperty
            
                def __new__(
                    cls,
                    _arg: typing.Union[typing.Tuple['ColumnNameProperty'], typing.List['ColumnNameProperty']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'primaryKey':
                    return super().__new__(
                        cls,
                        _arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'ColumnNameProperty':
                    return super().__getitem__(i)
            
            
            class partitionMode(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "none": "NONE",
                        "date": "DATE",
                        "int": "INT",
                    }
                
                @schemas.classproperty
                def NONE(cls):
                    return cls("none")
                
                @schemas.classproperty
                def DATE(cls):
                    return cls("date")
                
                @schemas.classproperty
                def INT(cls):
                    return cls("int")
        
            @staticmethod
            def datePartitionOptions() -> typing.Type['DatePartitionOptionsModel']:
                return DatePartitionOptionsModel
        
            @staticmethod
            def intPartitionOptions() -> typing.Type['IntPartitionOptionsModel']:
                return IntPartitionOptionsModel
            rowCount = schemas.IntSchema
            __annotations__ = {
                "name": name,
                "columns": columns,
                "primaryKey": primaryKey,
                "partitionMode": partitionMode,
                "datePartitionOptions": datePartitionOptions,
                "intPartitionOptions": intPartitionOptions,
                "rowCount": rowCount,
            }
    
    columns: MetaOapg.properties.columns
    name: 'ObjectNameProperty'
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> 'ObjectNameProperty': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["columns"]) -> MetaOapg.properties.columns: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["primaryKey"]) -> MetaOapg.properties.primaryKey: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["partitionMode"]) -> MetaOapg.properties.partitionMode: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["datePartitionOptions"]) -> 'DatePartitionOptionsModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["intPartitionOptions"]) -> 'IntPartitionOptionsModel': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rowCount"]) -> MetaOapg.properties.rowCount: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["name", "columns", "primaryKey", "partitionMode", "datePartitionOptions", "intPartitionOptions", "rowCount", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> 'ObjectNameProperty': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["columns"]) -> MetaOapg.properties.columns: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["primaryKey"]) -> typing.Union[MetaOapg.properties.primaryKey, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["partitionMode"]) -> typing.Union[MetaOapg.properties.partitionMode, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["datePartitionOptions"]) -> typing.Union['DatePartitionOptionsModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["intPartitionOptions"]) -> typing.Union['IntPartitionOptionsModel', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rowCount"]) -> typing.Union[MetaOapg.properties.rowCount, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["name", "columns", "primaryKey", "partitionMode", "datePartitionOptions", "intPartitionOptions", "rowCount", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        columns: typing.Union[MetaOapg.properties.columns, list, tuple, ],
        name: 'ObjectNameProperty',
        primaryKey: typing.Union[MetaOapg.properties.primaryKey, list, tuple, schemas.Unset] = schemas.unset,
        partitionMode: typing.Union[MetaOapg.properties.partitionMode, str, schemas.Unset] = schemas.unset,
        datePartitionOptions: typing.Union['DatePartitionOptionsModel', schemas.Unset] = schemas.unset,
        intPartitionOptions: typing.Union['IntPartitionOptionsModel', schemas.Unset] = schemas.unset,
        rowCount: typing.Union[MetaOapg.properties.rowCount, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'TableModel':
        return super().__new__(
            cls,
            *_args,
            columns=columns,
            name=name,
            primaryKey=primaryKey,
            partitionMode=partitionMode,
            datePartitionOptions=datePartitionOptions,
            intPartitionOptions=intPartitionOptions,
            rowCount=rowCount,
            _configuration=_configuration,
            **kwargs,
        )

from data_repo_client.model.column_model import ColumnModel
from data_repo_client.model.column_name_property import ColumnNameProperty
from data_repo_client.model.date_partition_options_model import DatePartitionOptionsModel
from data_repo_client.model.int_partition_options_model import IntPartitionOptionsModel
from data_repo_client.model.object_name_property import ObjectNameProperty
